import { getUserInfo, setWxAuthUserInfo, getThirdInfo, createAccount, changePhone } from '@/api/user.js';
import store from '@/store';
import config from '@/config';

// 获取用户数据
function getUserData() {
    return new Promise((resolve, reject) => {
        Promise.all([getUserInfo(), getThirdInfo()]).then(([userInfoRes, thirdInfores]) => {
            let userInfo = userInfoRes.data || {};
            let thirdInfo = thirdInfores.data || {};
            let cachedInfo = wx.getStorageSync('UserInfo');
            userInfo = { ...cachedInfo, ...userInfo, ...thirdInfo };
            userInfo.userName = userInfo.userName || '';
            // test 用户身份
            // userInfo.roles = ['tenant.admin', 'operator', 'owner'];
            // userInfo.phone = '';wxLogin
            // userInfo.nickName = '';
            // userInfo.userName = ''
            userInfo = addRolesInfoToUserInfo(userInfo);
            if (!userInfo.userName) {
                userInfo.defaultUserName = 'Hello';
            }
            // todo 模拟银泰配置 接口增加buildingLogo
            if (config.projectName === 'yintai') {
                userInfo.buildingLogo = `${config.h5StaticPath}/page-yintai/project-logo.png`;
            }
            //   userInfo.companyId = 'c68dcccd57984277ab7736f2d257cd0c'
            store.commit('setUserInfo', userInfo);
            resolve(userInfo);
        }).catch((res) => {
            reject(res);
        })
    })
}

// 检查登录
function checkLogin(needGetetUserInfo = true) {
    let token = store.state.user.token;
    if (!token) {
        return wxLogin(needGetetUserInfo);
    } else {
        return Promise.resolve();
    }
}

//  检查用户信息
function checkHasUserInfo() {
    let userInfo = store.state.user.userInfo;
    if (userInfo && JSON.stringify(userInfo) !== '{}') {
        return Promise.resolve(userInfo);
    } else {
        return checkLogin(false).then(() => {
            return getUserData();
        })
    }
}

export {
    checkHasUserInfo
}